## brlcad-7.32.4.tar.bz2

=== CMakeLists.txt ===
#                     C M A K E L I S T S . T X T
# BRL-CAD
#
# Copyright (c) 2010-2021 United States Government as represented by
# the U.S. Army Research Laboratory.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following
# disclaimer in the documentation and/or other materials provided
# with the distribution.
#
# 3. The name of the author may not be used to endorse or promote
# products derived from this software without specific prior written
# permission.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
# OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
# GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# NOTE: BRL-CAD as a collective work is distributed under the LGPL.
#       BRL-CAD's build system is under the BSD license.
#       See the COPYING file for more details.
#
# ******************************************************************
#
# Early versions of this CMakeLists.txt file were based on the VTK
# CMakeLists.txt file, also licensed under Modified BSD.

# *******************************************************************
# ***                 BRL-CAD's CMakeLists.txt                    ***
# *******************************************************************
#
# This file defines the toplevel CMake build logic for BRL-CAD.
# As best as is reasonably possible, proper ordering and
# separation of tests and settings should be maintained per the
# recommended standard layout.  The tests should be added to the
# labeled sections below so that they are organized in stages as
# follows:
#
#   Stage 0 - information on the package and toplevel CMake settings
#   Stage 1 - define top level options
#   Stage 2 - check programs
#   Stage 3 - check compiler characteristics
#   Stage 4 - check libraries
#   Stage 5 - check headers
#   Stage 6 - check types/structures
#   Stage 7 - check functions
#   Stage 8 - check system services
#   Stage 9 - define the BRL-CAD build targets
#
# The output summary should report key information about the final
# configuration of the build.  Comprehensive information is available
# in the CMake cache file in the build directory, so just hit the
# high points in the summary.
#
# After the main configure process is finished, a summary is printed
# and various settings and configuration files that require full
# knowledge of the main configure results are handled.
#
# *******************************************************************
# ***                 Top Level Settings                          ***
# *******************************************************************
# This file contains the top level CMakeLists.txt logic for the
# BRL-CAD software package.

# Minimum required version of CMake
cmake_minimum_required(VERSION 3.12)

# set CMake project name
project(BRLCAD)

# install(CODE) uses generator expressions - requires 3.14 or newer.
# We want it to be on, but until we can bump our minimum requirement
# set it to OLD to make sure we don't break anything.
if (POLICY CMP0087)
  cmake_policy(SET CMP0087 OLD)
endif (POLICY CMP0087)

# Test name character check - need to look into this one...
if (POLICY CMP0110)
  cmake_policy(SET CMP0110 OLD)
endif (POLICY CMP0110)

#---------------------------------------------------------------------
# CMake derives much of its functionality from modules, typically
# stored in one directory - let CMake know where to find them.  If we
# are a subbuild, let the parent's CMAKE_MODULE_PATH supply files before
# our own, otherwise misc/CMake takes first priority.
set(BRLCAD_CMAKE_DIR "${BRLCAD_SOURCE_DIR}/misc/CMake")
list(APPEND CMAKE_MODULE_PATH "${BRLCAD_CMAKE_DIR}")


#---------------------------------------------------------------------
# We definitely do not want a .gitattributes files present, as it is
# a potential source of subtle problems.  Bail with an explanation if
# it is found to be present.
if (EXISTS "${BRLCAD_SOURCE_DIR}/.gitattributes")
  message(FATAL_ERROR "\nBRL-CAD does not use a .gitattributes file in its repository.  This is intended to prevent subtle errors from creeping in due to inadvertant pattern matches.  See ${BRLCAD_SOURCE_DIR}/doc/git/mime_types.txt for an in-depth discussion of the recommended alternatives to use for the problems .gitattributes is intended to address.\n")
endif (EXISTS "${BRLCAD_SOURCE_DIR}/.gitattributes")


#---------------------------------------------------------------------
# Setup and checks related to system environment settings.  Some of
# these impact search results needed to set default options, so we
# do this early in the process.
include(BRLCAD_Environment_Setup)


#---------------------------------------------------------------------
# Define various utilities.
include(BRLCAD_Util)


#---------------------------------------------------------------------
# Define the current BRL-CAD version.
# See HACKING for details on how to properly update the version

file(READ "${BRLCAD_SOURCE_DIR}/include/conf/MAJOR" BRLCAD_VERSION_MAJOR)
string(STRIP ${BRLCAD_VERSION_MAJOR} BRLCAD_VERSION_MAJOR)
file(READ "${BRLCAD_SOURCE_DIR}/include/conf/MINOR" BRLCAD_VERSION_MINOR)
string(STRIP ${BRLCAD_VERSION_MINOR} BRLCAD_VERSION_MINOR)
file(READ "${BRLCAD_SOURCE_DIR}/include/conf/PATCH" BRLCAD_VERSION_PATCH)
string(STRIP ${BRLCAD_VERSION_PATCH} BRLCAD_VERSION_PATCH)

set(BRLCAD_VERSION "${BRLCAD_VERSION_MAJOR}.${BRLCAD_VERSION_MINOR}.${BRLCAD_VERSION_PATCH}")
if(DEFINED BRLCAD_VERSION_AMEND)
  set(BRLCAD_VERSION "${BRLCAD_VERSION}-${BRLCAD_VERSION_AMEND}")
endif(DEFINED BRLCAD_VERSION_AMEND)

#---------------------------------------------------------------------
# Let CMake know where to look for our counting file for configuration
# passes.  It will impact whether we print certain messages
set(BRLCAD_CNT_FILE "${BRLCAD_BINARY_DIR}/CMakeTmp/BRLCAD_BUILD_COUNT")
if(NOT EXISTS ${BRLCAD_CNT_FILE})
  set(BRLCAD_PRINT_MSGS 1)
else(NOT EXISTS ${BRLCAD_CNT_FILE})
  set(BRLCAD_PRINT_MSGS 0)
endif(NOT EXISTS ${BRLCAD_CNT_FILE})

#---------------------------------------------------------------------
# Define an option to use OBJECT libraries.  If we are building with object
# libraries, we need position independent code.
include(CMakeDependentOption)
cmake_dependent_option(USE_OBJECT_LIBS "Use OBJECT libraries" ON "NOT MSVC" OFF)
mark_as_advanced(USE_OBJECT_LIBS)
if(USE_OBJECT_LIBS)
  set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
endif(USE_OBJECT_LIBS)

#---------------------------------------------------------------------
# Record the CMake command line arguments (more or less) in
# CMakeFiles/CMakeOutput.log
record_cmdline_args()

#---------------------------------------------------------------------
# Set up the necessary support for timing of the configuration and
# build processes
string(TIMESTAMP CONFIG_DATE "%Y%m%d")
string(TIMESTAMP CONFIG_DATESTAMP "%a, %d %b %Y %H:%M:%S UTC" UTC)

#---------------------------------------------------------------------
# Mark the time at which the configuration process began.

set(CONFIG_DELTA_START "${CMAKE_BINARY_DIR}/CMakeTmp/CONFIG_DELTA_START")
execute_process(COMMAND "${CMAKE_COMMAND}" -DSTAMP_FILE=${CONFIG_DELTA_START} -P "${BRLCAD_CMAKE_DIR}/scripts/timestamp.cmake")

#---------------------------------------------------------------------
# Define relative install locations and output directories.  Don't set
# these if they have already been set by some other means (like a
# higher level CMakeLists.txt file including this one).
# For output directories - where built library and executable
# files will be placed after building but prior to install.  The
# necessary variables change between single and multi configuration
# build systems, so it is necessary to handle both cases on a
# conditional basis.

include(Path_Setup)

#---------------------------------------------------------------------
# Management of build types
if (NOT BRLCAD_IS_SUBBUILD)
  include(BRLCAD_Build_Types)
endif (NOT BRLCAD_IS_SUBBUILD)

#---------------------------------------------------------------------
# For cleaning files as part of the distclean command, CMake needs
# to be aware of what various generators will (or might) write out
# in each build directory.
set(DISTCLEAN_OUTFILES
  CTestTestfile.cmake
  Testing/Temporary/CTestCostData.txt
  Testing/Temporary/LastTest.log
  )
if("${CMAKE_GENERATOR}" MATCHES "Make")
  set(DISTCLEAN_OUTFILES ${DISTCLEAN_OUTFILES} Makefile)
endif("${CMAKE_GENERATOR}" MATCHES "Make")
if("${CMAKE_GENERATOR}" MATCHES "Ninja")
  set(DISTCLEAN_OUTFILES ${DISTCLEAN_OUTFILES} build.ninja rules.ninja .ninja_log)
endif("${CMAKE_GENERATOR}" MATCHES "Ninja")

#---------------------------------------------------------------------
# CMake's default "make test" target is a bit limited - define
# our own "unit" and "check" targets that automate more of the
# dependency updating process.
include(BRLCAD_Test_Wrappers)

#---------------------------------------------------------------------
# Load macros that will be used to define the BRL-CAD
# build logic
include(BRLCAD_Options)
include(BRLCAD_Targets)
include(CheckTypeSize)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)


#---------------------------------------------------------------------
# print out the title with a pretty box computed to wrap around
BOX_PRINT("*** Configuring BRL-CAD Release ${BRLCAD_VERSION}, Build ${CONFIG_DATE} ***" "*")

#---------------------------------------------------------------------
# Set up include paths for generated header files.  For multi-config
# builds, make sure we get build-specific dirs.
if(CMAKE_CONFIGURATION_TYPES)
  include_directories(${CMAKE_BINARY_DIR}/$<CONFIG>/${INCLUDE_DIR})
  include_directories(${CMAKE_BINARY_DIR}/$<CONFIG>/${INCLUDE_DIR}/brlcad)
else(CMAKE_CONFIGURATION_TYPES)
  include_directories(${CMAKE_BINARY_DIR}/${INCLUDE_DIR}/brlcad)
endif(CMAKE_CONFIGURATION_TYPES)

#---------------------------------------------------------------------
# We want to check /usr/local by default, so add it if it exists
if (IS_DIRECTORY /usr/local)
  set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} /usr/local)
  if (IS_DIRECTORY /usr/local/include)
    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /usr/local/include)
  endif (IS_DIRECTORY /usr/local/include)
endif (IS_DIRECTORY /usr/local)

#---------------------------------------------------------------------
# Intricacies involved with setting the install path mostly revolve
# around build type dependent install directories.  Also needs the
# current version defined.

include(BRLCAD_Install_Prefix)

#---------------------------------------------------------------------
# The following logic is what allows binaries to run successfully in
# the build directory AND install directory.  Thanks to plplot for
# identifying the necessity of setting CMAKE_INSTALL_NAME_DIR on OSX.
# Documentation of these options is available at
# http://www.cmake.org/Wiki/CMake_RPATH_handling

# TODO - once we've shifted to function invocation rather than having
# our logic execute on load, this "include" step will probably be
# consolidated into one large include...

=== bench/CMakeLists.txt ===
add_subdirectory(ref)

include_directories(${BU_INCLUDE_DIRS})

add_definitions(-DCONSOLE)

BRLCAD_ADDEXEC(pixcmp pixcmp.c libbu)
set(BARK_SOURCES
  benchmark.c
  compute.c
  run.c
  clean.c
)
BRLCAD_ADDEXEC(bark "${BARK_SOURCES}" libbu NO_STRICT NO_INSTALL TEST_USESDATA)

configure_file(run.sh "${CMAKE_CURRENT_BINARY_DIR}/benchmark" COPYONLY)
install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/benchmark" DESTINATION ${BIN_DIR})
DISTCLEAN("${CMAKE_CURRENT_BINARY_DIR}/benchmark")

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/benchmark-${CMAKE_CFG_INTDIR}-done
  COMMAND "${CMAKE_COMMAND}" -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/run.sh $<TARGET_FILE_DIR:bark>/benchmark
  COMMAND "${CMAKE_COMMAND}" -E touch  ${CMAKE_CURRENT_BINARY_DIR}/benchmark-${CMAKE_CFG_INTDIR}-done
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/run.sh
  )
add_custom_target(benchmark_cp ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/benchmark-${CMAKE_CFG_INTDIR}-done)
set_target_properties(benchmark_cp PROPERTIES FOLDER "Benchmark")
if(CMAKE_CONFIGURATION_TYPES)
  foreach(CFG_TYPE ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER "${CFG_TYPE}" CFG_TYPE_UPPER)
    DISTCLEAN(${CMAKE_BINARY_DIR_${CFG_TYPE_UPPER}}/${BIN_DIR}/benchmark)
  endforeach(CFG_TYPE ${CMAKE_CONFIGURATION_TYPES})
else(CMAKE_CONFIGURATION_TYPES)
  DISTCLEAN(${CMAKE_BINARY_DIR}/${BIN_DIR}/benchmark)
endif(CMAKE_CONFIGURATION_TYPES)

file(WRITE  "${CMAKE_BINARY_DIR}/CMakeTmp/benchmsg.cmake" "message(\"---\")\n")
file(APPEND "${CMAKE_BINARY_DIR}/CMakeTmp/benchmsg.cmake" "message(\"Run 'make benchmark-clean' in the bench directory to delete the logic\")\n")
file(APPEND "${CMAKE_BINARY_DIR}/CMakeTmp/benchmsg.cmake" "message(\"and image files generated during the benchmark analysis.\")\n")

CMAKEFILES(
  CMakeLists.txt
  lgt.sh
  run.sh
  try.sh
  viewdiff.sh
  )

if(SH_EXEC AND TARGET m35.g)
  # CTest enabled short run of the benchmark suite
  BRLCAD_ADD_TEST(NAME benchmark COMMAND ${SH_EXEC} "$<TARGET_FILE_DIR:bark>/benchmark" run TIMEFRAME=1)
  set_tests_properties(benchmark PROPERTIES LABELS "Benchmark")
  add_custom_target(benchmark-check
    COMMAND ${CMAKE_CTEST_COMMAND} -L Benchmark --output-on-failure
    DEPENDS rt pixcmp BENCHMARK_PIX_cp PIX_LOG_cp benchmark_cp
    )
  add_dependencies(benchmark-check bldg391.g m35.g moss.g sphflake.g star.g world.g)
  set_target_properties(benchmark-check PROPERTIES FOLDER "Benchmark")
  if(TARGET check)
    add_dependencies(check benchmark-check)
  endif(TARGET check)

  # Full run of the benchmark suite
  add_custom_target(benchmark
    COMMAND ${SH_EXEC} $<TARGET_FILE_DIR:bark>/benchmark run
    COMMAND ${CMAKE_COMMAND} -P "${CMAKE_BINARY_DIR}/CMakeTmp/benchmsg.cmake"
    DEPENDS rt pixcmp BENCHMARK_PIX_cp PIX_LOG_cp benchmark_cp
    )
  add_dependencies(benchmark bldg391.g m35.g moss.g sphflake.g star.g world.g)
  set_target_properties(benchmark PROPERTIES FOLDER "Benchmark")

  # benchmark cleanup targets
  add_custom_target(benchmark-clean
    ${SH_EXEC} ${CMAKE_BINARY_DIR}/bin/benchmark clean
    )
  set_target_properties(benchmark-clean PROPERTIES FOLDER "Benchmark")
  add_custom_target(benchmark-clobber
    ${SH_EXEC} ${CMAKE_BINARY_DIR}/bin/benchmark clobber
    )
  set_target_properties(benchmark-clobber PROPERTIES FOLDER "Benchmark")
endif(SH_EXEC AND TARGET m35.g)

# Local Variables:
# tab-width: 8
# mode: cmake
# indent-tabs-mode: t
# End:
# ex: shiftwidth=2 tabstop=8

=== db/CMakeLists.txt ===
# There is quite a bit of shared logic for the various converters when it comes
# to building .g outputs, so we use a single function to manage the process and
# handle format-specific bits internally.  TODO - we probably need to add
# optional argument support here later to support (say) specifying a specific
# COMGEOM or STEP format version...

function(ADD_G_TARGET in_model folder)

  # Initialize
  set(MODEL_TYPE "UNKNOWN")

  # Get our root path
  if(CMAKE_CONFIGURATION_TYPES)
    set(bin_root "${CMAKE_BINARY_DIR}/${CMAKE_CFG_INTDIR}")
  else(CMAKE_CONFIGURATION_TYPES)
    set(bin_root "${CMAKE_BINARY_DIR}")
  endif(CMAKE_CONFIGURATION_TYPES)

  # Find our conversion type
  set(model_types "3dm;asc;comgeom;fg4;stp")
  foreach(mt ${model_types})
    if("${MODEL_TYPE}" STREQUAL "UNKNOWN")
      if("${in_model}" MATCHES ".${mt}$")
	set(MODEL_TYPE "${mt}")
	string(REGEX REPLACE "([0-9a-z]*).${mt}" "\\1" in_model_root "${in_model}")
      endif("${in_model}" MATCHES ".${mt}$")
    endif("${MODEL_TYPE}" STREQUAL "UNKNOWN")
  endforeach(mt ${model_types})
  if("${MODEL_TYPE}" STREQUAL "UNKNOWN")
    message(FATAL_ERROR "Unable to identify input model type for file ${in_model}")
  endif("${MODEL_TYPE}" STREQUAL "UNKNOWN")

  # Find our output file and path
  string(REPLACE "${CMAKE_SOURCE_DIR}/" "" rel_dir "${CMAKE_CURRENT_SOURCE_DIR}")
  set(output_file ${DATA_DIR}/${rel_dir}/${in_model_root}.g)
  set(log_file ${CMAKE_CURRENT_BINARY_DIR}/${in_model_root}.log)

  # Make sure the output db target directories are there
  if(CMAKE_CONFIGURATION_TYPES)
    foreach(CFG_TYPE ${CMAKE_CONFIGURATION_TYPES})
      file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/${CFG_TYPE}/${DATA_DIR}/${rel_dir}")
    endforeach(CFG_TYPE ${CMAKE_CONFIGURATION_TYPES})
  else(CMAKE_CONFIGURATION_TYPES)
    file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/${DATA_DIR}/${rel_dir}")
  endif(CMAKE_CONFIGURATION_TYPES)

  #############################################################################
  #                            Build logic
  #############################################################################

  # The 3DM conversion is rather different than the general pattern at the
  # moment (However, the 3dm approach is probably the "wave of the future" in
  # the sense that it uses libgcv...)
  if(${MODEL_TYPE} STREQUAL "3dm")

    set(INPUT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${in_model}")
    set(OUTPUT_FILE "${output_file}")
    # Use the model name for the script, since the output file is specific to this input
    configure_file("${CMAKE_SOURCE_DIR}/db/conv_run.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/${in_model_root}.cmake" @ONLY)
    DISTCLEAN("${CMAKE_CURRENT_BINARY_DIR}/${in_model_root}.cmake")

    # Define the target
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BUILD_DIR_SCRIPT}/${output_file}
      COMMAND ${CMAKE_COMMAND} -DEXEC=$<TARGET_FILE:3dm-g> -P "${CMAKE_CURRENT_BINARY_DIR}/${in_model_root}.cmake"
      DEPENDS 3dm-g ${CMAKE_CURRENT_SOURCE_DIR}/${in_model}
      )

  endif(${MODEL_TYPE} STREQUAL "3dm")

  # The rest of the conversions follow the simpler/older pattern:

  if(${MODEL_TYPE} STREQUAL "asc")
    if (BRLCAD_ENABLE_TCL)
      add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BUILD_DIR_SCRIPT}/${output_file}
	COMMAND asc2g "${CMAKE_CURRENT_SOURCE_DIR}/${in_model}" ${CMAKE_CURRENT_BUILD_DIR_SCRIPT}/${output_file}
	DEPENDS asc2g "${CMAKE_CURRENT_SOURCE_DIR}/${in_model}"
	)
    endif (BRLCAD_ENABLE_TCL)
  endif(${MODEL_TYPE} STREQUAL "asc")

  if(${MODEL_TYPE} STREQUAL "comgeom")
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BUILD_DIR_SCRIPT}/${output_file}
      COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_CURRENT_BUILD_DIR_SCRIPT}/${output_file}
      COMMAND comgeom-g -v 5 ${CMAKE_CURRENT_SOURCE_DIR}/${in_model} ${CMAKE_CURRENT_BUILD_DIR_SCRIPT}/${output_file} > ${log_file} 2>&1
      DEPENDS comgeom-g ${CMAKE_CURRENT_SOURCE_DIR}/${in_model}
      )
  endif(${MODEL_TYPE} STREQUAL "comgeom")

  if(${MODEL_TYPE} STREQUAL "fg4")
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BUILD_DIR_SCRIPT}/${output_file}
      COMMAND fast4-g ${CMAKE_CURRENT_SOURCE_DIR}/${in_model} ${CMAKE_CURRENT_BUILD_DIR_SCRIPT}/${output_file} > ${log_file} 2>&1
      DEPENDS fast4-g ${CMAKE_CURRENT_SOURCE_DIR}/${in_model}
      )
  endif(${MODEL_TYPE} STREQUAL "fg4")

  if(${MODEL_TYPE} STREQUAL "stp")
    if (BRLCAD_ENABLE_STEP)
      add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BUILD_DIR_SCRIPT}/${output_file}
	COMMAND step-g -O ${CMAKE_CURRENT_BUILD_DIR_SCRIPT}/${output_file} ${CMAKE_CURRENT_SOURCE_DIR}/${in_model} > ${log_file} 2>&1
	DEPENDS step-g ${CMAKE_CURRENT_SOURCE_DIR}/${in_model}
	)
    else (BRLCAD_ENABLE_STEP)
      CMAKEFILES(${CMAKE_CURRENT_SOURCE_DIR}/${in_model})
    endif (BRLCAD_ENABLE_STEP)
  endif(${MODEL_TYPE} STREQUAL "stp")

  if(NOT ${MODEL_TYPE} STREQUAL "asc" OR BRLCAD_ENABLE_TCL)
    if(NOT ${MODEL_TYPE} STREQUAL "stp" OR BRLCAD_ENABLE_STEP)
      add_custom_target(${in_model_root}.g ALL DEPENDS ${CMAKE_CURRENT_BUILD_DIR_SCRIPT}/${output_file})
      set_target_properties(${in_model_root}.g PROPERTIES FOLDER "${folder}")

      # Install logic
      if(BRLCAD_INSTALL_EXAMPLE_GEOMETRY)
	install(FILES ${CMAKE_CURRENT_BUILD_DIR_INSTALL}/${output_file} DESTINATION ${DATA_DIR}/${rel_dir})
      endif(BRLCAD_INSTALL_EXAMPLE_GEOMETRY)

      # Clean-up
      set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES "${log_file}")
      DISTCLEAN("${log_file}")
    endif(NOT ${MODEL_TYPE} STREQUAL "stp" OR BRLCAD_ENABLE_STEP)
  endif(NOT ${MODEL_TYPE} STREQUAL "asc" OR BRLCAD_ENABLE_TCL)

endfunction(ADD_G_TARGET in_model folder)

set(G_BENCHMARK_MODELS
  bldg391.asc
  m35.asc
  moss.asc
  sphflake.asc
  star.asc
  world.asc
)

set(G_SAMPLE_MODELS
  aet.asc
  axis.asc
  bearing.asc
  boolean-ops.asc
  castle.asc
  cornell.asc
  cornell-kunigami.asc
  cray.asc
  crod.asc
  cube.asc
  demo.asc
  die.asc
  galileo.asc
  goliath.asc
  havoc.asc
  kman.asc
  ktank.asc
  lgt-test.asc
  operators.asc
  pic.asc
  pinewood.asc
  prim.asc
  radialgrid.asc
  rounds.asc
  tank_car.asc
  terra.asc
  toyjeep.asc
  truck.asc
  wave.asc
  woodsman.asc
  xmp.asc
)
add_subdirectory(chess)
add_subdirectory(comgeom)
add_subdirectory(nist)
add_subdirectory(faa)

foreach(g_input ${G_BENCHMARK_MODELS})
  ADD_G_TARGET(${g_input} "BRL-CAD Geometry Models/Benchmark")
endforeach(g_input ${G_BENCHMARK_MODELS})

foreach(g_input ${G_SAMPLE_MODELS})
  ADD_G_TARGET(${g_input} "BRL-CAD Geometry Models/Sample")
endforeach(g_input ${G_SAMPLE_MODELS})

if(BRLCAD_INSTALL_EXAMPLE_GEOMETRY)
   BRLCAD_ADDDATA(terra.dsp db)
endif(BRLCAD_INSTALL_EXAMPLE_GEOMETRY)

if(SH_EXEC)
  set(conversion_g_files)
  set(conversion_g_files_fp)
  set(conversion_deps_list)

  if (BRLCAD_ENABLE_TCL)
    macro(Sh_Conversion_Test gfile depends_list)
      add_custom_target(convert-${gfile} COMMAND ${SH_EXEC} ${CMAKE_SOURCE_DIR}/sh/conversion.sh GED=$<TARGET_FILE:mged> ${CMAKE_BINARY_DIR}/${DATA_DIR}/db/${gfile})
      set_target_properties(convert-${gfile} PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD 1)
      set_target_properties(convert-${gfile} PROPERTIES FOLDER "BRL-CAD Conversion Tests")
      set(conversion_g_files ${conversion_g_files} ${gfile})
      if(NOT "${depends_list}" STREQUAL "")
	add_dependencies(convert-${gfile} ${depends_list})
	set(conversion_deps_list ${conversion_deps_list} ${depends_list})
      endif(NOT "${depends_list}" STREQUAL "")
    endmacro(Sh_Conversion_Test)

    foreach(g_input ${G_BENCHMARK_MODELS})
      get_filename_component(GROOT "${g_input}" NAME_WE)
      Sh_Conversion_Test(${GROOT}.g "mged")
    endforeach(g_input ${G_BENCHMARK_MODELS})
    foreach(g_input ${G_SAMPLE_MODELS})
      get_filename_component(GROOT "${g_input}" NAME_WE)
      Sh_Conversion_Test(${GROOT}.g "mged")
    endforeach(g_input ${G_SAMPLE_MODELS})

    list(REMOVE_DUPLICATES conversion_deps_list)
    foreach(gfile ${conversion_g_files})
      set(conversion_g_files_fp ${conversion_g_files_fp} "${CMAKE_BINARY_DIR}/${DATA_DIR}/db/${gfile}")
    endforeach(gfile ${conversion_g_files})
    add_custom_target(convert COMMAND ${SH_EXEC} ${CMAKE_SOURCE_DIR}/sh/conversion.sh GED=$<TARGET_FILE:mged> ${conversion_g_files_fp})
    set_target_properties(convert PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD 1)
    set_target_properties(convert PROPERTIES FOLDER "BRL-CAD Conversion Tests")
    add_dependencies(convert ${conversion_deps_list})
  endif (BRLCAD_ENABLE_TCL)
endif(SH_EXEC)

CMAKEFILES(
  ${G_BENCHMARK_MODELS}
  ${G_SAMPLE_MODELS}
  CMakeLists.txt
  aet.rt
  conv_run.cmake.in
  cornell.rt
  cube.rt
  db.php
  include/ctype.inc
  include/debug.inc
  )

# Local Variables:
# tab-width: 8
# mode: cmake
# indent-tabs-mode: t
# End:
# ex: shiftwidth=2 tabstop=8

=== doc/CMakeLists.txt ===
verbose_add_subdirectory(doc docbook)
verbose_add_subdirectory(doc html)
verbose_add_subdirectory(doc legal)

set(documentation_DATA
  BRL-CAD.bib
  GITHUB
  IDEAS
  PROJECTS
  README.Linux
  README.MacOSX
  README.Windows
  README.BSD
  README.Solaris
  README.VAX
  checklist.txt
  description.txt
  notes/TODO.BREP
  notes/TODO.shaded_displays
  notes/brep.txt
  notes/bu_opt_design_notes.txt
  notes/cvs.txt
  notes/editors.txt
  notes/history.txt
  notes/hypot.txt
  notes/mater.txt
  notes/matrix.txt
  pre_BRL-CAD.bib
  )
ADD_DOC(documentation_DATA ".")

set(documentation_mged_old_DATA
  mged/a.tex
  mged/adc.ps
  mged/all.tex
  mged/axis-3525.ps
  mged/b.tex
  mged/buttonmenu.ps
  mged/c.tex
  mged/coord-axes.ps
  mged/crod-close.ps
  mged/crod.ps
  mged/d.tex
  mged/doit
  mged/e.tex
  mged/eo-arbrot.ps
  mged/eo-bgrp.ps
  mged/eo-bgrp311.ps
  mged/eo-cgrp.ps
  mged/eo-cgrp321.ps
  mged/eo-ellg.ps
  mged/eo-ellg2x.ps
  mged/eo-ellgxyz.ps
  mged/eo-gredit.ps
  mged/eo-grpath.ps
  mged/eo-scale.ps
  mged/eo-spread.ps
  mged/eo-stacked.ps
  mged/eo-start.ps
  mged/eo-tor111.ps
  mged/eo-xymove.ps
  mged/eo-xyzmove.ps
  mged/es5-edge1.ps
  mged/es5-edge2.ps
  mged/es5-edge3.ps
  mged/es5-edge4.ps
  mged/es5-rot.ps
  mged/es5-scale.ps
  mged/es5-sed.ps
  mged/es5-top.ps
  mged/es5-tr.ps
  mged/es5-xrot.ps
  mged/es8-edge1.ps
  mged/es8-edge2.ps
  mged/es8-edge3.ps
  mged/es8-ex1.ps
  mged/es8-ex2.ps
  mged/es8-rot.ps
  mged/es8-scale.ps
  mged/es8-sed.ps
  mged/es8-top.ps
  mged/es8-tr0.ps
  mged/es8-xrot.ps
  mged/es8-yrot.ps
  mged/es8-zrot.ps
  mged/esc-mh.ps
  mged/esc-mhrt.ps
  mged/esc-rot.ps
  mged/esc-sa.ps
  mged/esc-sb.ps
  mged/esc-sc.ps
  mged/esc-scale.ps
  mged/esc-sd.ps
  mged/esc-sed.ps
  mged/esc-sh.ps
  mged/esc-top.ps
  mged/esc-tr.ps
  mged/esc-xrot.ps
  mged/esc-yrot.ps
  mged/esc-zrot.ps
  mged/ese-sa.ps
  mged/ese-sb.ps
  mged/ese-sc.ps
  mged/ese-scale.ps
  mged/ese-sed.ps
  mged/ese-top.ps
  mged/ese-tr.ps
  mged/ese-xrot.ps
  mged/ese-yrot.ps
  mged/ese-zrot.ps
  mged/est-scale.ps
  mged/est-sed.ps
  mged/est-sr1.ps
  mged/est-sr2.ps
  mged/est-top.ps
  mged/est-tr.ps
  mged/est-xrot.ps
  mged/est-yrot.ps
  mged/est-zrot.ps
  mged/ex.arb4.ps
  mged/ex.arb8.ps
  mged/ex.box.ps
  mged/ex.ellg.ps
  mged/ex.raw.ps
  mged/ex.rcc.ps
  mged/ex.rpp.ps
  mged/ex.sph.ps
  mged/ex.tor.ps
  mged/ex.trc.ps
  mged/f.tex
  mged/faceplate.ps
  mged/faceplate1.ps
  mged/fig-sgi-buttons.ps
  mged/fig-sgi-knobs.ps
  mged/fig-sgi.ps
  mged/fig-vg-buttons.ps
  mged/fig-vg-knobs.ps
  mged/g.tex
  mged/h.tex
  mged/j.tex
  mged/k.tex
  mged/l.tex
  mged/m.tex
  mged/menu-arb-ctl.ps
  mged/menu-arb4-edge.ps
  mged/menu-arb4-face.ps
  mged/menu-arb4-rot.ps
  mged/menu-arb8-edge.ps
  mged/menu-arb8-face.ps
  mged/menu-arb8-rot.ps
  mged/obj-edit.ps
  mged/obj-path.ps
  mged/obj-pick.ps
  mged/ped-ell.ps
  mged/ped-tgc.ps
  mged/ped-tor.ps
  mged/plane-35a.ps
  mged/plane-35b.ps
  mged/plane-bot1.ps
  mged/plane-bot2.ps
  mged/plane-front1.ps
  mged/plane-front2.ps
  mged/plane-right1.ps
  mged/plane-right2.ps
  mged/plane-top1.ps
  mged/plane-top2.ps
  mged/rmit-3525.ps
  mged/robot.ps
  mged/sol-2pick.ps
  mged/sol-ed.ps
  mged/sol-pick.ps
  mged/t1-2s-pk.ps
  mged/t1-obj-ed.ps
  mged/t1-obj-ph.ps
  mged/t1-obj-pk.ps
  mged/t1-rot-vw.ps
  mged/t1-sol-ed.ps
  mged/t1-sol-pk.ps
  mged/t1-top-vw.ps
  mged/t1.tex
  mged/test.tex
  mged/v-arb8-side.ps
  mged/v-arb8-top.ps
  mged/wm-arm1.ps
  mged/wm-arm2.ps
  mged/wm-body.ps
  mged/wm-collar.ps
  mged/wm-final1.ps
  mged/wm-hat-E.ps
  mged/wm-hat1.ps
  mged/wm-hat2.ps
  mged/wm-hat3.ps
  mged/wm-head.ps
  mged/wm-leg1.ps
  mged/wm-prims.ps
  mged/wm-tube.ps
  notes/ecosystem.dot
  notes/regions.txt
  notes/rounding.txt
  notes/tool_categories.txt
  old-mged.tr
  )
ADD_DOC(documentation_mged_old_DATA mged_old)

configure_file(pad_file.xml.in "${CMAKE_CURRENT_BINARY_DIR}/pad_file.xml" @ONLY)
DISTCLEAN("${CMAKE_CURRENT_BINARY_DIR}/pad_file.xml")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/pad_file.xml" DESTINATION ${DOC_DIR})

CMAKEFILES(
  CMakeLists.txt
  STARTERS
  STRATEGY
  git/check.yml
  git/gitconfig
  git/gitk
  git/git2gource.cpp
  git/gource.txt
  git/gource.sh
  git/history.txt
  git/gitstats.txt
  git/mime_types.txt
  notes/bsd_semaphore_bug.txt
  notes/cmake_paths/CMakeLists.txt
  notes/cmake_paths/README.txt
  notes/cmake_paths/dir_info.c
  notes/cmake_paths/test.cmake.in
  notes/cmake_vars.txt
  notes/csv_to_comgeom.txt
  notes/implicit_constraints.txt
  notes/lcov.txt
  pad_file.xml.in
  )

# Generic C/C++ examples
CMAKEFILES(
  notes/c_cxx_patterns/01_basic_C/CMakeLists.txt
  notes/c_cxx_patterns/01_basic_C/main.c
  notes/c_cxx_patterns/01_basic_C/nlib.c
  notes/c_cxx_patterns/01_basic_C/nlib.h
  notes/c_cxx_patterns/02_hidden_C/CMakeLists.txt
  notes/c_cxx_patterns/02_hidden_C/main.c
  notes/c_cxx_patterns/02_hidden_C/nlib.c
  notes/c_cxx_patterns/02_hidden_C/nlib.h
  notes/c_cxx_patterns/03_PImpl_C/CMakeLists.txt
  notes/c_cxx_patterns/03_PImpl_C/main.c
  notes/c_cxx_patterns/03_PImpl_C/nlib.c
  notes/c_cxx_patterns/03_PImpl_C/nlib.h
  notes/c_cxx_patterns/04_hidden_CXX/CMakeLists.txt
  notes/c_cxx_patterns/04_hidden_CXX/main.c
  notes/c_cxx_patterns/04_hidden_CXX/nlib.cxx
  notes/c_cxx_patterns/04_hidden_CXX/nlib.h
  notes/c_cxx_patterns/05_PImpl_CXX/CMakeLists.txt
  notes/c_cxx_patterns/05_PImpl_CXX/main.c
  notes/c_cxx_patterns/05_PImpl_CXX/nlib.cxx
  notes/c_cxx_patterns/05_PImpl_CXX/nlib.h
  notes/c_cxx_patterns/CMakeLists.txt
  notes/c_cxx_patterns/README
  )

# Notes about parser generators
CMAKEFILES(
  notes/parsers/bison_to_lemon.txt
  notes/parsers/flex_to_re2c.txt
  notes/parsers/templates/CMakeLists.txt
  notes/parsers/templates/main.c
  notes/parsers/templates/main.h
  notes/parsers/templates/parser.lemon
  notes/parsers/templates/scanner.perplex
  notes/parsers/writing_perplex_lemon_parsers.txt
  )

# Local Variables:
# tab-width: 8
# mode: cmake
# indent-tabs-mode: t
# End:
# ex: shiftwidth=2 tabstop=8

=== include/CMakeLists.txt ===
add_subdirectory(analyze)
add_subdirectory(bu)
add_subdirectory(bn)
add_subdirectory(bg)
add_subdirectory(brep)
add_subdirectory(dm)
add_subdirectory(gcv)
add_subdirectory(ged)
add_subdirectory(icv)
add_subdirectory(nmg)
add_subdirectory(optical)
add_subdirectory(rt)

set(public_hdrs
  RtServerImpl.h
  analyze.h
  bg.h
  bio.h
  bn.h
  bnetwork.h
  brep.h
  bresource.h
  brlcad.h
  brlcad.i
  bsocket.h
  bu.h
  common.h
  dm.h
  fft.h
  gcv.h
  ged.h
  icv.h
  libtermio.h
  nmg.h
  optical.h
  pc.h
  photonmap.h
  pinttypes.h
  pkg.h
  pstdint.h
  raytrace.h
  rtserver.h
  tclcad.h
  vmath.h
  wdb.h
  )
BRLCAD_MANAGE_FILES("${public_hdrs}" ${INCLUDE_DIR}/brlcad)

BUILD_CFG_HDR(brlcad_ident.h.in ${INCLUDE_DIR}/brlcad)
BUILD_CFG_HDR(brlcad_version.h.in ${INCLUDE_DIR}/brlcad)

# FIXME: shouldn't exist, needs to be absorbed into brlcad_config.h
if(MSVC)
  BUILD_CFG_HDR(config_win.h.in ${INCLUDE_DIR}/brlcad)
endif(MSVC)

set(include_misc
  CMakeLists.txt
  brlcad_ident.h.in
  brlcad_version.h.in
  conf/BrlcadConfig.tmpl
  conf/MAJOR
  conf/MINOR
  conf/PATCH
  conf/make.vbs
  config_win.h.in
  )
CMAKEFILES(${include_misc})

# Header checking target - this compiles the headers as isolated files to
# ensure they include what is needed to resolve any symbols defined in the
# public API.

# Note: don't know how to do this on Windows - skip with Visual Studio
if (DEFINED BRLCAD_HDR_CHECK AND NOT MSVC)

  add_custom_target(check-headers)
  set_target_properties(check-headers PROPERTIES FOLDER "BRL-CAD Header Checks")

  file(GLOB_RECURSE hdrfiles RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "*.h")

  foreach(hdrfile ${hdrfiles})

    if (NOT "${hdrfile}" STREQUAL "RtServerImpl.h")

      string(REPLACE "-" "_" STMPFILE "${hdrfile}")
      string(REPLACE "." "_" STMPFILE "${STMPFILE}")
      string(REPLACE "/" "_" STMPFILE "${STMPFILE}")

      add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${STMPFILE}.stamp
	COMMAND ${CMAKE_CXX_COMPILER} -I${CMAKE_SOURCE_DIR}/include -I${CMAKE_BINARY_DIR}/include
	-I${CMAKE_SOURCE_DIR}/src/other/openNURBS -I${CMAKE_SOURCE_DIR}/src/other/tcl/generic
	-fsyntax-only -Wall -Wextra -Wno-deprecated
	${CMAKE_CURRENT_SOURCE_DIR}/${hdrfile}
	COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/${STMPFILE}.stamp
	DEPENDS ${hdrfile}
	)
      add_custom_target(${STMPFILE}-check DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${STMPFILE}.stamp)
      set_target_properties(${STMPFILE}-check PROPERTIES FOLDER "BRL-CAD Header Checks")

      add_dependencies(check-headers ${STMPFILE}-check)

    endif (NOT "${hdrfile}" STREQUAL "RtServerImpl.h")

  endforeach(hdrfile ${hdrfiles})

endif (DEFINED BRLCAD_HDR_CHECK AND NOT MSVC)



# Local Variables:
# tab-width: 8
# mode: cmake
# indent-tabs-mode: t
# End:
# ex: shiftwidth=2 tabstop=8

=== misc/CMakeLists.txt ===
if(BUILD_STATIC_LIBS AND BRLCAD_ENABLE_BRLCAD_LIBRARY)
  add_subdirectory(win32-msvc)
endif(BUILD_STATIC_LIBS AND BRLCAD_ENABLE_BRLCAD_LIBRARY)

set(prefix "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix "\${prefix}")
set(libdir "\${exec_prefix}/lib")
set(includedir "\${prefix}/include")
set(datarootdir "\${prefix}/share")
set(datadir "\${datarootdir}")

add_subdirectory(pkgconfig)
add_subdirectory(perl)
add_subdirectory(attributes)
add_subdirectory(opencl-raytracer-tests)

if(NOT CMAKE_CONFIGURATION_TYPES)
  configure_file(brlcad-config.in ${CMAKE_BINARY_DIR}/misc/brlcad-config @ONLY)
  file(COPY ${CMAKE_BINARY_DIR}/misc/brlcad-config
    DESTINATION ${CMAKE_BINARY_DIR}/${BIN_DIR}
    FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ
    GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
  DISTCLEAN(${CMAKE_BINARY_DIR}/${BIN_DIR}/brlcad-config)
  file(REMOVE ${CMAKE_BINARY_DIR}/misc/brlcad-config)
  install(PROGRAMS ${CMAKE_BINARY_DIR}/bin/brlcad-config DESTINATION ${BIN_DIR})
else(NOT CMAKE_CONFIGURATION_TYPES)
  foreach(CFG_TYPE ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER "${CFG_TYPE}" CFG_TYPE_UPPER)
    configure_file(brlcad-config.in ${CMAKE_BINARY_DIR}/${CFG_TYPE_UPPER}/misc/brlcad-config @ONLY)
    file(COPY ${CMAKE_BINARY_DIR}/${CFG_TYPE_UPPER}/misc/brlcad-config
      DESTINATION ${CMAKE_BINARY_DIR_${CFG_TYPE_UPPER}}/${BIN_DIR}
      FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ
      GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
    DISTCLEAN(${CMAKE_BINARY_DIR_${CFG_TYPE_UPPER}}/${BIN_DIR}/brlcad-config)
    file(REMOVE ${CMAKE_BINARY_DIR}/${CFG_TYPE_UPPER}/misc/brlcad-config)
  endforeach(CFG_TYPE ${CMAKE_CONFIGURATION_TYPES})
  install(PROGRAMS ${CMAKE_BINARY_DIR}/\${BUILD_TYPE}/bin/brlcad-config DESTINATION ${BIN_DIR})
endif(NOT CMAKE_CONFIGURATION_TYPES)

BRLCAD_ADDDATA(fortran_example.f sample_applications)

set(density_DATAFILES
  GQA_SAMPLE_DENSITIES
  NIST_DENSITIES
  )
BRLCAD_ADDDATA(density_DATAFILES data)

add_subdirectory(nirt)

BRLCAD_ADDDATA(profont/ProFont.ttf fonts)

BRLCAD_ADDDATA(nsis/brlcad.ico icons)
BRLCAD_ADDDATA(nsis/archer.ico icons)


add_subdirectory(doxygen)
add_subdirectory(CMake)
add_subdirectory(debian)
add_subdirectory(osl_shaders)

set(misc_ignore_files
  Bullet_Box_Chain_Demo.cpp
  CMakeLists.txt
  Description.txt
  Makefile.defs
  archlinux/PKGBUILD
  archlinux/brlcad.install
  astyle.opt
  auto-man-page/BIN_OPT_ARG_ANALYSIS.txt
  auto-man-page/README.auto-man-page-handling
  auto-man-page/auto-man-progs.txt
  batch-indent-region.el
  brlcad-config.in
  brlcad.spec.in
  check/adj_air.sh
  check/exp_air.sh
  check/overlaps.sh
  check/rtcheck.sh
  check/volume.sh
  check/gap.sh
  clang-static-analyzer-run.sh
  flawfinder
  hawaii_islands.sh
  jove.emacs
  macosx/README
  macosx/Resources/License.rtf
  macosx/Resources/ReadMe.rtfd/.typeAttributes.dict
  macosx/Resources/ReadMe.rtfd/TXT.rtf
  macosx/Resources/ReadMe.rtfd/brlcad_logo_tiny.png
  macosx/Resources/Welcome.rtfd/.typeAttributes.dict
  macosx/Resources/Welcome.rtfd/TXT.rtf
  macosx/Resources/Welcome.rtfd/brlcad_logo_tiny.png
  macosx/background.png
  macosx/openUp.c
  mime.types
  mime_cad.types
  nsis/archer.ico
  nsis/brlcad.ico
  nsis/header.bmp
  nsis/side.bmp
  nsis/uninstall.ico
  profont/LICENSE
  profont/profont-IIx-charmap.png
  profont/profont_IIx_readme.pdf
  profont/readme.txt
  uncpowerplant2g.sh
  win32-msvc/CMakeLists.txt
  win32-msvc/Dll/BrlcadCore.def
  win32-msvc/Dll/BrlcadCore.rc
  win32-msvc/Dll/CMakeLists.txt
  win32-msvc/Dll/TclDummies.c
  win32-msvc/Dll/brlcad.def
  win32-msvc/Dll/brlcad.rc
  win32-msvc/bootstrap.cpp
  wix/License.rtf
  wix/brlcad_banner.bmp
  wix/brlcad_dialog.bmp
  wix/brlcad_product.ico
  )
CMAKEFILES(${misc_ignore_files})
# Local Variables:
# tab-width: 8
# mode: cmake
# indent-tabs-mode: t
# End:
# ex: shiftwidth=2 tabstop=8

=== regress/CMakeLists.txt ===
# Define the toplevel regression target - unless specifically excluded
# via a macro argument, this should collect all regression targets.
include(ProcessorCount)
ProcessorCount(N)
if(NOT N EQUAL 0 AND NOT BRLCAD_SERIAL_TESTING)
  set(JFLAG "-j${N}")
else()
  set(JFLAG)
endif()
if (CMAKE_CONFIGURATION_TYPES)
  add_custom_target(regress COMMAND ${CMAKE_CTEST_COMMAND} -C ${CMAKE_CFG_INTDIR} -L Regression --output-on-failure --output-log "${CMAKE_BINARY_DIR}/regress_output.log" ${JFLAG})
else (CMAKE_CONFIGURATION_TYPES)
  add_custom_target(regress COMMAND ${CMAKE_CTEST_COMMAND} -L Regression --output-on-failure --output-log "${CMAKE_BINARY_DIR}/regress_output.log" ${JFLAG})
endif (CMAKE_CONFIGURATION_TYPES)
DISTCLEAN(${CMAKE_BINARY_DIR}/regress_output.log)
set_target_properties(regress PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD 1)
set_target_properties(regress PROPERTIES FOLDER "BRL-CAD Regression Tests")

# ASC file Conversion Tests
add_subdirectory(asc)

# Bag of Triangles Tests
add_subdirectory(bots)

# Burst Regression Tests
add_subdirectory(burst)

# comgeom Conversion Tests
add_subdirectory(comgeom)

# Coverage Tests
add_subdirectory(coverage)

# DSP Regression Tests
add_subdirectory(dsp)

# Fuzz tests (if supported by the compiler)
add_subdirectory(fuzz)

# Geometry difference reporting
add_subdirectory(gdiff)

# Image Conversion Regression Tests
add_subdirectory(icv)

# gchecker tests
add_subdirectory(gchecker)

# Geometry Editing Library Regression Tests
add_subdirectory(ged)

# Geometry Conversion Regression Tests
add_subdirectory(gcv)

# GQA Regression Tests
add_subdirectory(gqa)

# IGES Regression Tests
add_subdirectory(iges)

# License check
add_subdirectory(licenses)

# light tests
add_subdirectory(lights)

# MGED command tests
add_subdirectory(mged)

# moss.g Regression Tests
add_subdirectory(moss)

# NIRT Regression Tests
add_subdirectory(nirt)

# NURBS Regression Tests
add_subdirectory(nurbs)

# libpkg Regression Tests
add_subdirectory(pkg)

# Region EDit (red) Regression Tests
add_subdirectory(red)

# Repository check
add_subdirectory(repository)

# rtedge Regression Tests
add_subdirectory(rtedge)

# RtWizard Image Generation Regression Tests
add_subdirectory(rtwizard)

# Simulation of a 3rd party BRL-CAD library client code
add_subdirectory(user)

# solids Regression Tests
add_subdirectory(solids)

# spdi Regression Tests
add_subdirectory(spdi)

# shaders Regression Tests
add_subdirectory(shaders)

# rtweight command tests
add_subdirectory(weight)

if(SH_EXEC)

  BRLCAD_ADD_TEST(NAME regress-usage COMMAND ${SH_EXEC} "${CMAKE_SOURCE_DIR}/regress/usage.sh" ${CMAKE_SOURCE_DIR})
  BRLCAD_REGRESSION_TEST(regress-usage "rt" STAND_ALONE TEST_DEFINED)

  # TODO - test for Python before adding this one
  BRLCAD_ADD_TEST(NAME regress-flawfinder COMMAND ${SH_EXEC} "${CMAKE_SOURCE_DIR}/regress/flawfinder.sh" ${CMAKE_SOURCE_DIR})
  BRLCAD_REGRESSION_TEST(regress-flawfinder "" STAND_ALONE TEST_DEFINED)

endif(SH_EXEC)

CMAKEFILES(
  flawfinder.sh
  g-dot.sh
  g-nff.sh
  library.sh
  usage.sh
  )

CMAKEFILES(CMakeLists.txt)

# Local Variables:
# tab-width: 8
# mode: cmake
# indent-tabs-mode: t
# End:
# ex: shiftwidth=2 tabstop=8

=== sh/CMakeLists.txt ===
# Note: elapsed.sh is installed because it is used by benchmark
set(sh_SCRIPTS
  elapsed.sh
  cmp.sh
  conversion.sh
  show.sh
  )
foreach(script ${sh_SCRIPTS})
  if(NOT CMAKE_CONFIGURATION_TYPES)
    file(COPY ${script} DESTINATION ${CMAKE_BINARY_DIR}/bin FILE_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)
    DISTCLEAN("${CMAKE_BINARY_DIR}/bin/${script}")
  else(NOT CMAKE_CONFIGURATION_TYPES)
    foreach(CFG_TYPE ${CMAKE_CONFIGURATION_TYPES})
      string(TOUPPER "${CFG_TYPE}" CFG_TYPE_UPPER)
      file(COPY ${script} DESTINATION ${CMAKE_BINARY_DIR_${CFG_TYPE_UPPER}}/bin FILE_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)
      DISTCLEAN("${CMAKE_BINARY_DIR_${CFG_TYPE_UPPER}}/bin/${script}")
    endforeach(CFG_TYPE ${CMAKE_CONFIGURATION_TYPES})
  endif(NOT CMAKE_CONFIGURATION_TYPES)
endforeach(script ${sh_SCRIPTS})

install(PROGRAMS ${sh_SCRIPTS} DESTINATION ${BIN_DIR} PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)

set(noinst_SCRIPTS
  copyright.sh
  enumerate.sh
  footer.sh
  fs2org.sh
  header.sh
  indent.sh
  ios-icons.sh
  linkroot.sh
  make_deb.sh
  make_dmg.sh
  make_rpm.sh
  news2tracker.sh
  template.sh
  ws.sh
  )
CMAKEFILES(${sh_SCRIPTS})
CMAKEFILES(${noinst_SCRIPTS})
CMAKEFILES(CMakeLists.txt)

# Local Variables:
# tab-width: 8
# mode: cmake
# indent-tabs-mode: t
# End:
# ex: shiftwidth=2 tabstop=8

=== src/CMakeLists.txt ===
# Define high level features of BRL-CAD
DOXYGEN_FEATURE("Portability Library" DESCRIPTION "Portability layer that makes sure basic low level system functionality is present across all platforms via a uniform API.")
DOXYGEN_FEATURE("Solid Raytracing" DESCRIPTION "Ray/geometry intersection calculations that report not just first surface hits but in/out pairs of hits to support the characterization of closed geometric volumes.")


# Minimal directories required for any BRL-CAD functionality

if(MSVC)
  add_definitions(
    -D_CRT_SECURE_NO_WARNINGS
    )
endif(MSVC)

# We need to define a number of "components" to allow for easy building of
# subsets of BRL-CAD.  We will control this process with an advanced
# variable named BRLCAD_ENABLE_TARGETS - if set to 0 (default) everything
# will be enabled.

# Level 1 directories are required for all other BRL-CAD components.  If you
# build anything else, you will need to build these.  If you want JUST librt
# and its requirements, set BRLCAD_ENABLE_TARGETS to 1
set(level_1_dirs
  libbu
  libbn
  libbg
  libnmg
  libbrep
  librt
  libwdb
  )

# Level 2 directories are the remainder of BRL-CAD's libraries.  Setting
# the BRLCAD_ENABLE_TARGETS level to 2 will enable all libraries but no
# programs.

set(level_2_dirs
  libpkg
  libgcv
  libanalyze
  liboptical
  libged
  libdm
  libfft
  libicv
  libpc
  libtclcad
  libtermio
  )

# Level 3 directories contain BRL-CAD's executables.  Setting
# the BRLCAD_ENABLE_TARGETS level to 3 will enable all programs.

set(level_3_dirs
  brlman
  burst
  bwish
  conv
  fb
  fbserv
  gtools
  nirt
  proc-db
  rt
  art
  shapes
  sig
  util
  qged
  external
  remrt
  # tclscripts must come before applications like
  # mged and archer that need the scripts in place to
  # run. The script target lists are defined when the tclscripts
  # directories are configured, and those lists are needed
  # as dependencies for the targets in these directories
  tclscripts
  adrt
  rtwizard
  archer
  mged
  )

# Now that we have our lists, proceed with the actual
# add_subdirectory commands.  We find the highest
# number used to define a level_#_dir, and add the
# levels in order up to the limit specified by
# BRLCAD_ENABLE_TARGETS (or all of them if the value
# is 0)
set(HIGHEST_TARGET_LEVEL 0)
set(has_contents 1)
while(has_contents)
  math(EXPR current_level "${HIGHEST_TARGET_LEVEL} + 1")
  if(NOT "${level_${current_level}_dirs}" STREQUAL "")
    set(HIGHEST_TARGET_LEVEL ${current_level})
  else(NOT "${level_${current_level}_dirs}" STREQUAL "")
    set(has_contents 0)
  endif(NOT "${level_${current_level}_dirs}" STREQUAL "")
endwhile(has_contents)

# If we didn't already a limit, set to the highest level
if(NOT BRLCAD_ENABLE_TARGETS)
  set(BRLCAD_ENABLE_TARGETS ${HIGHEST_TARGET_LEVEL})
else(NOT BRLCAD_ENABLE_TARGETS)
  if(${BRLCAD_ENABLE_TARGETS} GREATER ${HIGHEST_TARGET_LEVEL})
    message(WARNING "BRL-CAD Target level ${BRLCAD_ENABLE_TARGETS} specified, but highest level defined is ${HIGHEST_TARGET_LEVEL}")
    set(BRLCAD_ENABLE_TARGETS ${HIGHEST_TARGET_LEVEL})
  endif(${BRLCAD_ENABLE_TARGETS} GREATER ${HIGHEST_TARGET_LEVEL})
endif(NOT BRLCAD_ENABLE_TARGETS)

# Now we know what to do - proceed.  If we're not using it,
# be sure to marked it as an ignored directory for CMake.
set(current_level 0)
while(${current_level} LESS ${HIGHEST_TARGET_LEVEL})
  math(EXPR current_level "${current_level} + 1")
  foreach(subdir ${level_${current_level}_dirs})
    if(${current_level} LESS ${BRLCAD_ENABLE_TARGETS} OR ${current_level} EQUAL ${BRLCAD_ENABLE_TARGETS} )
      verbose_add_subdirectory(src ${subdir})
    endif(${current_level} LESS ${BRLCAD_ENABLE_TARGETS} OR ${current_level} EQUAL ${BRLCAD_ENABLE_TARGETS} )
  endforeach(subdir ${level_${current_level}_dirs})
endwhile(${current_level} LESS ${HIGHEST_TARGET_LEVEL})

# This corresponds roughly to the libbrlcad originally defined in BRL-CAD
# autotools build.
if(BRLCAD_ENABLE_BRLCAD_LIBRARY AND USE_OBJECT_LIBS)
  set(current_level 1)
  while(${current_level} LESS ${HIGHEST_TARGET_LEVEL})
    set(wl 1)
    math(EXPR cml "${current_level} + 1")
    while(${wl} LESS ${cml})
      foreach(llib ${level_${wl}_dirs})
	if(TARGET ${llib})
	  set(libbrlcad_objs ${libbrlcad_objs} $<TARGET_OBJECTS:${llib}-obj>)
	endif(TARGET ${llib})
      endforeach(llib ${level_${wl}_dirs})
      math(EXPR wl "${wl} + 1")
    endwhile(${wl} LESS ${cml})
    if("${current_level}" EQUAL 1)
      add_library(libbrlcad-core SHARED ${libbrlcad_objs})
      add_library(libbrlcad-core-static STATIC ${libbrlcad_objs})
    endif("${current_level}" EQUAL 1)
    if("${current_level}" EQUAL 2)
      add_library(libbrlcad SHARED ${libbrlcad_objs})
      add_library(libbrlcad-static STATIC ${libbrlcad_objs})
    endif("${current_level}" EQUAL 2)
    math(EXPR current_level "${current_level} + 1")
  endwhile(${current_level} LESS ${HIGHEST_TARGET_LEVEL})
endif(BRLCAD_ENABLE_BRLCAD_LIBRARY AND USE_OBJECT_LIBS)

CMAKEFILES(
  CMakeLists.txt
  README
  )

# Add a convenience directory that is only added to the
# build if it exists.  This directory is ignored by svn,
# so it can be used for experimentation that needs to be
# part of the build but the dev doesn't want to accidentally
# commit.
if("${BRLCAD_ENABLE_TARGETS}" GREATER 2 AND EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/testing)
  add_subdirectory(testing)
endif("${BRLCAD_ENABLE_TARGETS}" GREATER 2 AND EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/testing)


# Local Variables:
# tab-width: 8
# mode: cmake
# indent-tabs-mode: t
# End:
# ex: shiftwidth=2 tabstop=8

=== bench/ref/CMakeLists.txt ===
set(BENCHMARK_PIX
  bldg391.pix
  m35.pix
  moss.pix
  sphflake.pix
  star.pix
  world.pix
  )


set(PIX_LOG
  bldg391.log
  m35.log
  moss.log
  sphflake.log
  star.log
  world.log
  )

BRLCAD_ADDDATA(BENCHMARK_PIX pix)
BRLCAD_ADDDATA(PIX_LOG pix)

CMAKEFILES(${BENCHMARK_PIX})
CMAKEFILES(${PIX_LOG})
CMAKEFILES(CMakeLists.txt)

# Local Variables:
# tab-width: 8
# mode: cmake
# indent-tabs-mode: t
# End:
# ex: shiftwidth=2 tabstop=8

=== db/chess/CMakeLists.txt ===
set(CHESS_PARTS
  bishop.asc
  chessboard.asc
  king.asc
  knight.asc
  pawn.asc
  queen.asc
  rook.asc
  )

foreach(piece ${CHESS_PARTS})
  ADD_G_TARGET(${piece} "BRL-CAD Geometry Models/Sample/Chess")
endforeach(piece ${CHESS_PARTS})

CMAKEFILES(
  ${CHESS_PARTS}
  CMakeLists.txt
  )

# Local Variables:
# tab-width: 8
# mode: cmake
# indent-tabs-mode: t
# End:
# ex: shiftwidth=2 tabstop=8

=== db/comgeom/CMakeLists.txt ===
set(COMGEOM_V5_MODELS
  ADA073408.comgeom
)

foreach(comgeom_input ${COMGEOM_V5_MODELS})
  ADD_G_TARGET(${comgeom_input} "BRL-CAD Geometry Models/Sample")
endforeach(comgeom_input ${COMGEOM_V5_MODELS})

CMAKEFILES(
  ${COMGEOM_V5_MODELS}
  CMakeLists.txt
  README_ADA073408
  ADA073408_inputs.tar.gz
)

# Local Variables:
# tab-width: 8
# mode: cmake
# indent-tabs-mode: t
# End:
# ex: shiftwidth=2 tabstop=8

=== misc/debian/changelog ===
brlcad (7.32.4-0) unstable; urgency=low

  * update brlcad version

 -- Cliff Yapp <cyapp@brlcad.org>  Sat, 26 Jul 2021 06:27:49 UTC

brlcad (7.32.2-0) unstable; urgency=low

  * update brlcad version

 -- Cliff Yapp <cyapp@brlcad.org>  Sat, 06 Feb 2021 04:20:16 UTC 

brlcad (7.32.0-0) unstable; urgency=low

  * update brlcad version

 -- Cliff Yapp <cyapp@brlcad.org>  Mon, 14 Sep 2020 09:50:40 UTC 

brlcad (7.30.8-0) unstable; urgency=low

  * update brlcad version

 -- Cliff Yapp <cyapp@brlcad.org>  Wed, 13 Apr 2020 05:34:29 UTC 

brlcad (7.30.6-0) unstable; urgency=low

  * update brlcad version

 -- Cliff Yapp <cyapp@brlcad.org>  Wed, 26 Feb 2020 21:20:56 UTC 

brlcad (7.30.4-0) unstable; urgency=low

  * update brlcad version

 -- Cliff Yapp <cyapp@brlcad.org>  Tue, 05 Dec 2019 21:56:32 UTC

brlcad (7.30.2-0) unstable; urgency=low

  * update brlcad version

 -- Cliff Yapp <cyapp@brlcad.org>  Tue, 02 Apr 2019 12:45:47 -0400

brlcad (7.30.0-0) unstable; urgency=low

  * update brlcad version

 -- Cliff Yapp <cyapp@brlcad.org>  Mon, 25 Feb 2019 13:57:48 -0400

brlcad (7.28.2-0) unstable; urgency=low

  * update brlcad version

 -- Cliff Yapp <cyapp@brlcad.org>  Thu, 29 Nov 2018 18:29:24 -0400

brlcad (7.28.0-0) unstable; urgency=low

  * update brlcad version

 -- Cliff Yapp <cyapp@brlcad.org>  Thu, 30 Sep 2010 23:05:54 -0400

brlcad (7.26.4-0) unstable; urgency=low

  * update brlcad version

 -- Cliff Yapp <cyapp@brlcad.org>  Thu, 22 Sep 2017 17:21:44 -0400

brlcad (7.26.2-0) unstable; urgency=low

  * update brlcad version

 -- Cliff Yapp <cyapp@brlcad.org>  Thu, 08 Jun 2017 18:39:57 -0400

brlcad (7.26.0-0) unstable; urgency=low

  * update brlcad version

 -- Jordi Sayol <g.sayol@yahoo.es>  Wed, 18 May 2016 21:40:10 +0200

brlcad (7.24.2-0) unstable; urgency=low

  * update brlcad version

 -- Jordi Sayol <g.sayol@yahoo.es>  Thu, 05 Sep 2013 23:44:51 +0200

brlcad (7.24.0-0) unstable; urgency=low

  * update brlcad version

 -- Jordi Sayol <g.sayol@yahoo.es>  Mon, 25 Jun 2012 20:09:17 +0200

brlcad (7.22.0-0) unstable; urgency=low

  * update brlcad version

 -- Jordi Sayol <g.sayol@yahoo.es>  Tue, 24 Jan 2012 21:53:52 +0100

brlcad (7.20.4-0) unstable; urgency=low

  * moved to CMAKE building
  * changed mime-types names and mime-types icons names

 -- Jordi Sayol <g.sayol@yahoo.es>  Wed, 24 Aug 2011 12:12:44 +0200

brlcad (7.18.6-0) unstable; urgency=low

  - new BRL-CAD release

 -- Jordi Sayol <g.sayol@yahoo.es>  Sat, 16 Apr 2011 14:41:48 +0200

brlcad (7.18.4-0) unstable; urgency=low

  * add magic mime-type association for geometry db file v.4 and v.5
  * add new mime-type icons for geometry db file v.4 and v.5

 -- Jordi Sayol <g.sayol@yahoo.es>  Sat, 05 Mar 2011 23:10:51 +0100

brlcad (7.18.2-0) unstable; urgency=low

  * created new menu entries
  * added new icons
  * created new brlcad geometry mime-type
  * added brlcad geometry file mime-type association
  * switched from shared libraries to build-in ones
  * switched --prefix from /usr to /usr/brlcad
  * modified sh/make_deb.sh builder script

 -- Jordi Sayol <g.sayol@yahoo.es>  Sat, 29 Jan 2011 12:05:33 +0100

brlcad (7.16.10-1) unstable; urgency=low

  * Initial release (Closes: #289632).

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Wed, 25 Aug 2010 11:16:45 +0200

=== misc/archlinux/PKGBUILD ===
###
#
# This is the BRL-CAD package file for Arch Linux.
#
# Contributor: Loui Chang <louipc.ist@NOSPAMgmail.com>
#
###
pkgname=brlcad
pkgdesc="An extensive 3D solid modeling CAD system."
_major=$(cat ../../include/conf/MAJOR)
_minor=$(cat ../../include/conf/MINOR)
_patch=$(cat ../../include/conf/PATCH)
pkgver=$_major.$_minor.$_patch
pkgrel=1
url="http://brlcad.org"
license=('LGPL' 'BSD' 'custom:BDL')
arch=('i686' 'x86_64')
install=$pkgname.install
makedepends=('bc' 'libxslt')
depends=('boost' 'flex' 'libgl' 'libpng' 'mesa' 'tk' 'zlib')

optdepends=(
    'fop: for building pdf documentation'
)

options=('!libtool' '!strip' 'docs')

_pkgprefix=/opt/$pkgname

build() {
    mkdir $srcdir/build
    cd $srcdir/build

    cmake $startdir/../../ \
    -DCMAKE_INSTALL_PREFIX=${_pkgprefix} \
    -DCMAKE_BUILD_TYPE=Release \
    -DBRLCAD_ENABLE_STRICT=OFF

    make
}

package() {
    cd $srcdir/build

    make DESTDIR=$pkgdir install

    mkdir -p $pkgdir/etc/profile.d
    echo "export PATH=\$PATH:$_pkgprefix/bin" > $pkgdir/etc/profile.d/$pkgname.sh
    chmod 755 $pkgdir/etc/profile.d/$pkgname.sh

    mkdir -p $pkgdir/usr/share/licenses/$pkgname
    cp $srcdir/../../doc/legal/bdl.txt \
        $pkgdir/usr/share/licenses/$pkgname
    cp $srcdir/../../doc/legal/bsd.txt \
        $pkgdir/usr/share/licenses/$pkgname

    mkdir -p $pkgdir/etc/ld.so.conf.d
    echo ${_pkgprefix}/lib > $pkgdir/etc/ld.so.conf.d/$pkgname.conf
}

=== misc/debian/control ===
Source: brlcad
Section: graphics
Priority: optional
Maintainer: Jordi Sayol <g.sayol@yahoo.es>
Build-Depends: build-essential, fakeroot, debhelper (>= 7.0.0), make (>= 3.8.0), cmake, sed, bison, flex, libxi-dev, xsltproc, libglu1-mesa-dev, libpango1.0-dev
Standards-Version: 3.9.1
Homepage: http://brlcad.org/
Vcs-Svn: https://brlcad.svn.sourceforge.net/svnroot/brlcad/
Vcs-Browser: http://brlcad.svn.sourceforge.net/viewvc/brlcad/

Package: brlcad
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, xterm
Description: BRL-CAD open source solid modeling
 BRL-CAD is a powerful cross-platform Open Source combinatorial
 Constructive Solid Geometry (CSG) solid modeling system that
 includes interactive 3D solid geometry editing, high-performance
 ray-tracing support for rendering and geometric analysis,
 network-distributed framebuffer support, image and signal-processing
 tools, path-tracing and photon mapping support for realistic image
 synthesis, a system performance analysis benchmark suite, an embedded
 scripting interface, and libraries for robust high-performance
 geometric representation and analysis.

=== misc/debian/rules ===
#!/usr/bin/make -f

# Author: Jordi Sayol <g.sayol@yahoo.es>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# override dpkg-buildflags flags
CFLAGS =
CPPFLAGS =
CXXFLAGS =
FFLAGS =
LDFLAGS =

# DEB_BUILD_OPTIONS

ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
    PARALLEL_JOBS = $(shell echo $(DEB_BUILD_OPTIONS) | \
        sed -e 's/.*parallel=\([0-9]\+\).*/\1/')
    PARALLEL_OPTIONS = -j$(PARALLEL_JOBS)
endif

build: build-stamp

build-stamp:
	dh_testdir

	cmake -DCMAKE_INSTALL_PREFIX=/usr/brlcad -DBRLCAD_ENABLE_STRICT=OFF

	$(MAKE) $(PARALLEL_OPTIONS)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	dh_clean

install: install-stamp

install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs -a
	dh_installchangelogs -a
	dh_install -a --list-missing
	dh_compress -a
	dh_fixperms -a
#	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-arch
.PHONY: build clean binary-arch binary install
